﻿Imports DBHandlerVB.DBHandlerVB.Implementation
Imports System.Data
Imports System.Globalization

Public Class GiftItemsReportObjects

    Private ItemsDistributed As List(Of DistributedItems)

    Public Function GetAllGiftItems() As List(Of DistributedItems)
        ItemsDistributed = New List(Of DistributedItems)()
        Using wrapper As New DbWrapper("DbConnection")
            Using reader = wrapper.GetDataReader("SELECT ItemNo, GiftDistributionNo, ItemName, Quantity, UnitCost, Amount, UsageCategory, ItemEnteredBy FROM GiftItems ORDER BY ItemNo ASC", CommandType.Text)
                While reader.Read()
                    ItemsDistributed.Add(New DistributedItems(Convert.ToInt32(reader("ItemNo"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("GiftDistributionNo"), CultureInfo.InvariantCulture), Convert.ToString(reader("ItemName"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("Quantity"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("UnitCost"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("Amount"), CultureInfo.InvariantCulture), Convert.ToString(reader("UsageCategory"), CultureInfo.InvariantCulture), Convert.ToString(reader("ItemEnteredBy"), CultureInfo.InvariantCulture)))
                End While
            End Using
        End Using
        Return ItemsDistributed
    End Function

    Public Function GetGiftItemsByRange(ByVal firstValue As Integer, ByVal secondValue As Integer) As List(Of DistributedItems)
        ItemsDistributed = New List(Of DistributedItems)()
        Using wrapper As New DBWrapper("DbConnection")
            wrapper.CreateParameter("@FirstValue", firstValue, DbType.Int32)
            wrapper.CreateParameter("@SecondValue", secondValue, DbType.Int32)
            Using reader = wrapper.GetDataReader("SELECT ItemNo, GiftDistributionNo, ItemName, Quantity, UnitCost, Amount, UsageCategory, ItemEnteredBy FROM GiftItems WHERE ItemNo>=@FirstValue AND ItemNo<=@SecondValue ORDER BY ItemNo ASC", CommandType.Text)
                While reader.Read()
                    ItemsDistributed.Add(New DistributedItems(Convert.ToInt32(reader("ItemNo"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("GiftDistributionNo"), CultureInfo.InvariantCulture), Convert.ToString(reader("ItemName"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("Quantity"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("UnitCost"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("Amount"), CultureInfo.InvariantCulture), Convert.ToString(reader("UsageCategory"), CultureInfo.InvariantCulture), Convert.ToString(reader("ItemEnteredBy"), CultureInfo.InvariantCulture)))
                End While
            End Using
            wrapper.ClearParameters()
        End Using
        Return ItemsDistributed
    End Function

    Public Function GetGiftItemsByWord(ByVal searchWord As String) As List(Of DistributedItems)
        ItemsDistributed = New List(Of DistributedItems)()
        Using wrapper As New DbWrapper("DbConnection")
            Using reader = wrapper.GetDataReader("SELECT ItemNo, GiftDistributionNo, ItemName, Quantity, UnitCost, Amount, UsageCategory, ItemEnteredBy FROM GiftItems WHERE  LTRIM(STR(ItemNo)) LIKE '%" & searchWord & "%' OR LTRIM(STR(GiftDistributionNo)) LIKE '%" & searchWord & "%' OR ItemName LIKE '%" & searchWord & "%' OR  LTRIM(STR(Quantity)) LIKE '%" & searchWord & "%' OR LTRIM(STR(UnitCost)) LIKE '%" & searchWord & "%' OR  LTRIM(STR(Amount)) LIKE '%" & searchWord & "%' OR  UsageCategory LIKE '%" & searchWord & "%' OR ItemEnteredBy LIKE '%" & searchWord & "%' ORDER BY ItemNo ASC", CommandType.Text)
                While reader.Read()
                    ItemsDistributed.Add(New DistributedItems(Convert.ToInt32(reader("ItemNo"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("GiftDistributionNo"), CultureInfo.InvariantCulture), Convert.ToString(reader("ItemName"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("Quantity"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("UnitCost"), CultureInfo.InvariantCulture), Convert.ToInt32(reader("Amount"), CultureInfo.InvariantCulture), Convert.ToString(reader("UsageCategory"), CultureInfo.InvariantCulture), Convert.ToString(reader("ItemEnteredBy"), CultureInfo.InvariantCulture)))
                End While
            End Using
        End Using
        Return ItemsDistributed
    End Function

End Class

'This works as the dataset for the report viewer
''' <summary>
''' 	
''' </summary>
Public Class DistributedItems
    Private _itemNumber As Integer
    Private _giftDistributionNumber As Integer
    Private _itemDescription As String
    Private _itemQuantity As Integer
    Private _itemUnitCost As Double
    Private _totalItemAmount As Double
    Private _itemUsageCategory As String
    Private _staffEnteredItemBy As String


    ''' <summary>
    ''' Initializes a new instance of the <see cref="DistributedItems"/> class.	
    ''' </summary>
    ''' <param name="itemNumber">The item number.</param>
    ''' <param name="giftDistributionNumber">The gift distribution number.</param>
    ''' <param name="itemDescription">The item description.</param>
    ''' <param name="itemQuantity">The item quantity.</param>
    ''' <param name="itemUnitCost">The item unit cost.</param>
    ''' <param name="totalItemAmount">The total item amount.</param>
    ''' <param name="itemUsageCategory">The item usage category.</param>
    ''' <param name="staffEnteredItemBy">The staff entered item by.</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal itemNumber As Integer, ByVal giftDistributionNumber As Integer, ByVal itemDescription As String, ByVal itemQuantity As Integer, ByVal itemUnitCost As Double, ByVal totalItemAmount As Double, ByVal itemUsageCategory As String, ByVal staffEnteredItemBy As String)
        _itemNumber = itemNumber
        _giftDistributionNumber = giftDistributionNumber
        _itemDescription = itemDescription
        _itemQuantity = itemQuantity
        _itemUnitCost = itemUnitCost
        _totalItemAmount = totalItemAmount
        _itemUsageCategory = itemUsageCategory
        _staffEnteredItemBy = staffEnteredItemBy

    End Sub

    ''' <summary>
    ''' Gets the item number.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The item number.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property ItemNumber() As Integer
        Get
            Return _itemNumber
        End Get
    End Property


    ''' <summary>
    ''' Gets the gift distribution number.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The gift distribution number.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property GiftDistributionNumber() As Integer
        Get
            Return _giftDistributionNumber
        End Get
        'Set(ByVal Value As Integer)
        '    _giftDistributionNumber = Value
        'End Set
    End Property


    ''' <summary>
    ''' Gets the item description.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The item description.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property ItemDescription() As String
        Get
            Return _itemDescription
        End Get
        'Set(ByVal Value As String)
        '    _itemDescription = Value
        'End Set
    End Property


    ''' <summary>
    ''' Gets the item quantity.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The item quantity.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property ItemQuantity() As Integer
        Get
            Return _itemQuantity
        End Get
        'Set(ByVal Value As Integer)
        '    _itemQuantity = Value
        'End Set
    End Property


    ''' <summary>
    ''' Gets the item unit cost.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The item unit cost.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property ItemUnitCost() As Double
        Get
            Return _itemUnitCost
        End Get
        'Set(ByVal Value As Double)
        '    _itemUnitCost = Value
        'End Set
    End Property


    ''' <summary>
    ''' Gets the total item amount.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The total item amount.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property TotalItemAmount() As Double
        Get
            Return _totalItemAmount
        End Get
        'Set(ByVal Value As Double)
        '    _totalItemAmount = Value
        'End Set
    End Property


    ''' <summary>
    ''' Gets the item usage category.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The item usage category.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property ItemUsageCategory() As String
        Get
            Return _itemUsageCategory
        End Get
        'Set(ByVal Value As String)
        '    _itemUsageCategory = Value
        'End Set
    End Property


    ''' <summary>
    ''' Gets the staff entered item by.	
    ''' </summary>
    ''' <returns></returns>
    ''' <value>The staff entered item by.</value>
    ''' <remarks></remarks>
    Public ReadOnly Property StaffEnteredItemBy() As String
        Get
            Return _staffEnteredItemBy
        End Get
        'Set(ByVal Value As String)
        '    _staffEnteredItemBy = Value
        'End Set
    End Property

End Class
