﻿Imports System
Imports DevExpress.XtraReports.UI
Imports Wisej.Web

Partial Public Class GiftItemsReport
    Inherits Form

    Protected selectedReport As String = String.Empty

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Sub LoadAllGiftItems()
        Dim GiftItemsreport As New XtraReport1()
        Dim GiftItemsObj As New GiftItemsReportObjects()
        GiftItemsreport.DataSource = GiftItemsObj.GetAllGiftItems
        asPxWebDocumentViewerWrapper1.OpenReport(GiftItemsreport)
        GiftItemsreport.CreateDocument()
    End Sub

    Public Sub LoadPhaseGetItemsReport()
        Dim searchWord As String = Trim(txtReportSearch.Text)
        Dim GiftItemsreport As New XtraReport1()
        Dim GiftItemsObj As New GiftItemsReportObjects()
        GiftItemsreport.DataSource = GiftItemsObj.GetGiftItemsByWord(searchWord)
        asPxWebDocumentViewerWrapper1.OpenReport(GiftItemsreport)
        GiftItemsreport.CreateDocument()
    End Sub

    Public Sub LoadParameterizedGetItemsReport()
        Dim firstValue As Integer = Convert.ToInt32(txtStartSearchValue.Text)
        Dim secondValue As Integer = Convert.ToInt32(txtEndSearchValue.Text)
        Dim GiftItemsreport As New XtraReport1()
        Dim GiftItemsObj As New GiftItemsReportObjects()
        GiftItemsreport.DataSource = GiftItemsObj.GetGiftItemsByRange(firstValue, secondValue)
        asPxWebDocumentViewerWrapper1.OpenReport(GiftItemsreport)
        GiftItemsreport.CreateDocument()
    End Sub

    Private Sub asPxWebDocumentViewerWrapper1_LoadComplete(ByVal sender As Object, ByVal e As EventArgs) Handles asPxWebDocumentViewerWrapper1.LoadComplete
        SwitchReportingScope()
    End Sub

    Private Sub ActionAllDataReport_Click(sender As Object, e As EventArgs) Handles ActionAllDataReport.Click
        selectedReport = "All"
        AddHandler asPxWebDocumentViewerWrapper1.LoadComplete, AddressOf asPxWebDocumentViewerWrapper1_LoadComplete
    End Sub

    Private Sub ActionPhaseBasedReport_Click(sender As Object, e As EventArgs) Handles ActionPhaseBasedReport.Click
        selectedReport = "PhaseBased"
        AddHandler asPxWebDocumentViewerWrapper1.LoadComplete, AddressOf asPxWebDocumentViewerWrapper1_LoadComplete
    End Sub

    Private Sub ActionRangeBasedReport_Click(sender As Object, e As EventArgs) Handles ActionRangeBasedReport.Click
        selectedReport = "ParameterBased"
        AddHandler asPxWebDocumentViewerWrapper1.LoadComplete, AddressOf asPxWebDocumentViewerWrapper1_LoadComplete
    End Sub

    Private Sub SwitchReportingScope()
        If selectedReport = String.Empty Then
            Return
        ElseIf selectedReport Is "All" Then
            LoadAllGiftItems()
        ElseIf selectedReport Is "PhaseBased" Then
            LoadPhaseGetItemsReport()
        ElseIf selectedReport Is "ParameterBased" Then
            LoadParameterizedGetItemsReport()
        End If
    End Sub
End Class
